#include <httpd.h>
#include <okbc.h>

#include "mod_3store.h"
#include "handlers.h"

static const int true  = 1;
static const int false = 0;

#define btoi(bool) (*bool == 't' ? 1 : 0)

okbc_node *handle_add_class_superclass(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *new_superclass;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-superclass"))) {
         new_superclass = ret;
    } else {
         r->status_line = "400 Required argment 'new-superclass' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_add_class_superclass(class, new_superclass, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_add_facet_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *value;
    char *kb = NULL;
    char *test = key_equal;
    char *slot_type = key_own;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "test"))) {
        test = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_add_facet_value(frame, slot, facet, value, kb, test, slot_type, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_add_instance_type(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *new_type;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-type"))) {
         new_type = ret;
    } else {
         r->status_line = "400 Required argment 'new-type' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_add_instance_type(frame, new_type, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_add_slot_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *value;
    char *kb = NULL;
    char *test = key_equal;
    char *slot_type = key_own;
    char *add_before = "0";
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "test"))) {
        test = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "add-before"))) {
        add_before = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_add_slot_value(frame, slot, value, kb, test, slot_type, add_before, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_all_connections(request_rec *r, char *args[MAX_ARGS+1][2])
{
    return okbc_all_connections();
}

okbc_node *handle_allocate_frame_handle(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame_name;
    char *frame_type;
    char *kb = NULL;
    char *frame_handle = NULL;

    if ((ret = has_arg(args, "frame-name"))) {
         frame_name = ret;
    } else {
         r->status_line = "400 Required argment 'frame-name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "frame-type"))) {
         frame_type = ret;
    } else {
         r->status_line = "400 Required argment 'frame-type' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "frame-handle"))) {
        frame_handle = ret;
    }

    return okbc_allocate_frame_handle(frame_name, frame_type, kb, frame_handle);
}

okbc_node *handle_ask(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *query;
    char *kb = NULL;
    char *reply_pattern = "query";
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   error_p = true;
    char *where = NULL;
    char *timeout = NULL;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "query"))) {
         query = ret;
    } else {
         r->status_line = "400 Required argment 'query' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "reply-pattern"))) {
        reply_pattern = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "where"))) {
        where = ret;
    }

    if ((ret = has_arg(args, "timeout"))) {
        timeout = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_ask(query, kb, reply_pattern, inference_level, number_of_values, error_p, where, timeout, value_selector, kb_local_only_p);
}

okbc_node *handle_askable(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *sentence;
    char *kb = NULL;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "sentence"))) {
         sentence = ret;
    } else {
         r->status_line = "400 Required argment 'sentence' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_askable(sentence, kb, value_selector, kb_local_only_p);
}

okbc_node *handle_attach_facet(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *slot_type = key_own;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_attach_facet(frame, slot, facet, kb, slot_type, kb_local_only_p);

    return NULL;
}

okbc_node *handle_attach_slot(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *slot_type = key_own;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_attach_slot(frame, slot, kb, slot_type, kb_local_only_p);

    return NULL;
}

okbc_node *handle_call_procedure(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *procedure;
    char *kb = NULL;
    char *arguments = NULL;

    if ((ret = has_arg(args, "procedure"))) {
         procedure = ret;
    } else {
         r->status_line = "400 Required argment 'procedure' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "arguments"))) {
        arguments = ret;
    }

    return okbc_call_procedure(procedure, kb, arguments);
}

okbc_node *handle_class_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_class_p(thing, kb, kb_local_only_p);
}

okbc_node *handle_close_connection(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *connection;
    int   force_p = 0;
    int   error_p = true;

    if ((ret = has_arg(args, "connection"))) {
         connection = ret;
    } else {
         r->status_line = "400 Required argment 'connection' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "force-p"))) {
        force_p = btoi(ret);
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    okbc_close_connection(connection, force_p, error_p);

    return NULL;
}

okbc_node *handle_close_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    int   save_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "save-p"))) {
        save_p = btoi(ret);
    }

    okbc_close_kb(kb, save_p);

    return NULL;
}

okbc_node *handle_coerce_to_class(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   error_p = true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_coerce_to_class(thing, kb, error_p, kb_local_only_p);
}

okbc_node *handle_coerce_to_facet(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   error_p = true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_coerce_to_facet(thing, kb, error_p, kb_local_only_p);
}

okbc_node *handle_coerce_to_frame(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   error_p = true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_coerce_to_frame(thing, kb, error_p, kb_local_only_p);
}

okbc_node *handle_coerce_to_individual(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   error_p = true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_coerce_to_individual(thing, kb, error_p, kb_local_only_p);
}

okbc_node *handle_coerce_to_kb_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *string_or_value;
    char *target_context;
    char *kb = NULL;
    int   wildcards_allowed_p = 0;
    int   force_case_insensitive_p = 0;
    int   error_p = true;
    char *frame_action = key_error_if_not_unique;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "string-or-value"))) {
         string_or_value = ret;
    } else {
         r->status_line = "400 Required argment 'string-or-value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "target-context"))) {
         target_context = ret;
    } else {
         r->status_line = "400 Required argment 'target-context' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "wildcards-allowed-p"))) {
        wildcards_allowed_p = btoi(ret);
    }

    if ((ret = has_arg(args, "force-case-insensitive-p"))) {
        force_case_insensitive_p = btoi(ret);
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "frame-action"))) {
        frame_action = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_coerce_to_kb_value(string_or_value, target_context, kb, wildcards_allowed_p, force_case_insensitive_p, error_p, frame_action, kb_local_only_p);
}

okbc_node *handle_coerce_to_slot(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   error_p = true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_coerce_to_slot(thing, kb, error_p, kb_local_only_p);
}

okbc_node *handle_coercible_to_frame_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_coercible_to_frame_p(thing, kb, kb_local_only_p);
}

okbc_node *handle_connection_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    return okbc_connection_p(thing);
}

okbc_node *handle_continuable_error_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    return okbc_continuable_error_p(thing);
}

okbc_node *handle_copy_frame(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *new_name;
    char *kb = NULL;
    char *to_kb = "(current-kb)";
    int   error_p = true;
    char *missing_frame_action = key_stop;
    char *frame_handle_mapping_table = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-name"))) {
         new_name = ret;
    } else {
         r->status_line = "400 Required argment 'new-name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "to-kb"))) {
        to_kb = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "missing-frame-action"))) {
        missing_frame_action = ret;
    }

    if ((ret = has_arg(args, "frame-handle-mapping-table"))) {
        frame_handle_mapping_table = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_copy_frame(frame, new_name, kb, to_kb, error_p, missing_frame_action, frame_handle_mapping_table, kb_local_only_p);
}

okbc_node *handle_copy_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *from_kb;
    char *to_kb;
    int   error_p = true;
    char *missing_frame_action = key_stop;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "from-kb"))) {
         from_kb = ret;
    } else {
         r->status_line = "400 Required argment 'from-kb' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "to-kb"))) {
         to_kb = ret;
    } else {
         r->status_line = "400 Required argment 'to-kb' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "missing-frame-action"))) {
        missing_frame_action = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_copy_kb(from_kb, to_kb, error_p, missing_frame_action, kb_local_only_p);

    return NULL;
}

okbc_node *handle_create_class(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name;
    char *kb = NULL;
    char *direct_types = NULL;
    char *direct_superclasses = NULL;
    int   primitive_p = true;
    char *doc = NULL;
    char *template_slots = NULL;
    char *template_facets = NULL;
    char *own_slots = NULL;
    char *own_facets = NULL;
    char *handle = NULL;
    char *pretty_name = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "direct-types"))) {
        direct_types = ret;
    }

    if ((ret = has_arg(args, "direct-superclasses"))) {
        direct_superclasses = ret;
    }

    if ((ret = has_arg(args, "primitive-p"))) {
        primitive_p = btoi(ret);
    }

    if ((ret = has_arg(args, "doc"))) {
        doc = ret;
    }

    if ((ret = has_arg(args, "template-slots"))) {
        template_slots = ret;
    }

    if ((ret = has_arg(args, "template-facets"))) {
        template_facets = ret;
    }

    if ((ret = has_arg(args, "own-slots"))) {
        own_slots = ret;
    }

    if ((ret = has_arg(args, "own-facets"))) {
        own_facets = ret;
    }

    if ((ret = has_arg(args, "handle"))) {
        handle = ret;
    }

    if ((ret = has_arg(args, "pretty-name"))) {
        pretty_name = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_create_class(name, kb, direct_types, direct_superclasses, primitive_p, doc, template_slots, template_facets, own_slots, own_facets, handle, pretty_name, kb_local_only_p);
}

okbc_node *handle_create_facet(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name;
    char *kb = NULL;
    char *frame_or_nil = NULL;
    char *slot_or_nil = NULL;
    char *slot_type = key_own;
    char *direct_types = NULL;
    char *doc = NULL;
    char *own_slots = NULL;
    char *own_facets = NULL;
    char *handle = NULL;
    char *pretty_name = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "frame-or-nil"))) {
        frame_or_nil = ret;
    }

    if ((ret = has_arg(args, "slot-or-nil"))) {
        slot_or_nil = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "direct-types"))) {
        direct_types = ret;
    }

    if ((ret = has_arg(args, "doc"))) {
        doc = ret;
    }

    if ((ret = has_arg(args, "own-slots"))) {
        own_slots = ret;
    }

    if ((ret = has_arg(args, "own-facets"))) {
        own_facets = ret;
    }

    if ((ret = has_arg(args, "handle"))) {
        handle = ret;
    }

    if ((ret = has_arg(args, "pretty-name"))) {
        pretty_name = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_create_facet(name, kb, frame_or_nil, slot_or_nil, slot_type, direct_types, doc, own_slots, own_facets, handle, pretty_name, kb_local_only_p);
}

okbc_node *handle_create_frame(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name;
    char *frame_type;
    char *kb = NULL;
    char *direct_types = NULL;
    char *direct_superclasses = NULL;
    char *doc = NULL;
    char *template_slots = NULL;
    char *template_facets = NULL;
    char *own_slots = NULL;
    char *own_facets = NULL;
    int   primitive_p = true;
    char *handle = NULL;
    char *pretty_name = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "frame-type"))) {
         frame_type = ret;
    } else {
         r->status_line = "400 Required argment 'frame-type' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "direct-types"))) {
        direct_types = ret;
    }

    if ((ret = has_arg(args, "direct-superclasses"))) {
        direct_superclasses = ret;
    }

    if ((ret = has_arg(args, "doc"))) {
        doc = ret;
    }

    if ((ret = has_arg(args, "template-slots"))) {
        template_slots = ret;
    }

    if ((ret = has_arg(args, "template-facets"))) {
        template_facets = ret;
    }

    if ((ret = has_arg(args, "own-slots"))) {
        own_slots = ret;
    }

    if ((ret = has_arg(args, "own-facets"))) {
        own_facets = ret;
    }

    if ((ret = has_arg(args, "primitive-p"))) {
        primitive_p = btoi(ret);
    }

    if ((ret = has_arg(args, "handle"))) {
        handle = ret;
    }

    if ((ret = has_arg(args, "pretty-name"))) {
        pretty_name = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_create_frame(name, frame_type, kb, direct_types, direct_superclasses, doc, template_slots, template_facets, own_slots, own_facets, primitive_p, handle, pretty_name, kb_local_only_p);
}

okbc_node *handle_create_individual(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name;
    char *kb = NULL;
    char *direct_types = NULL;
    char *doc = NULL;
    char *own_slots = NULL;
    char *own_facets = NULL;
    char *handle = NULL;
    char *pretty_name = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "direct-types"))) {
        direct_types = ret;
    }

    if ((ret = has_arg(args, "doc"))) {
        doc = ret;
    }

    if ((ret = has_arg(args, "own-slots"))) {
        own_slots = ret;
    }

    if ((ret = has_arg(args, "own-facets"))) {
        own_facets = ret;
    }

    if ((ret = has_arg(args, "handle"))) {
        handle = ret;
    }

    if ((ret = has_arg(args, "pretty-name"))) {
        pretty_name = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_create_individual(name, kb, direct_types, doc, own_slots, own_facets, handle, pretty_name, kb_local_only_p);
}

okbc_node *handle_create_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name;
    char *kb_type = NULL;
    char *kb_locator = NULL;
    char *initargs = NULL;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "kb-locator"))) {
        kb_locator = ret;
    }

    if ((ret = has_arg(args, "initargs"))) {
        initargs = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_create_kb(name, kb_type, kb_locator, initargs, connection);
}

okbc_node *handle_create_kb_locator(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb_type = NULL;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_create_kb_locator(thing, kb_type, connection);
}

okbc_node *handle_create_procedure(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *arguments = NULL;
    char *body = NULL;
    char *environment = NULL;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "arguments"))) {
        arguments = ret;
    }

    if ((ret = has_arg(args, "body"))) {
        body = ret;
    }

    if ((ret = has_arg(args, "environment"))) {
        environment = ret;
    }

    return okbc_create_procedure(kb, arguments, body, environment);
}

okbc_node *handle_create_slot(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name;
    char *kb = NULL;
    char *frame_or_nil = NULL;
    char *slot_type = key_all;
    char *direct_types = NULL;
    char *doc = NULL;
    char *own_slots = NULL;
    char *own_facets = NULL;
    char *handle = NULL;
    char *pretty_name = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "frame-or-nil"))) {
        frame_or_nil = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "direct-types"))) {
        direct_types = ret;
    }

    if ((ret = has_arg(args, "doc"))) {
        doc = ret;
    }

    if ((ret = has_arg(args, "own-slots"))) {
        own_slots = ret;
    }

    if ((ret = has_arg(args, "own-facets"))) {
        own_facets = ret;
    }

    if ((ret = has_arg(args, "handle"))) {
        handle = ret;
    }

    if ((ret = has_arg(args, "pretty-name"))) {
        pretty_name = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_create_slot(name, kb, frame_or_nil, slot_type, direct_types, doc, own_slots, own_facets, handle, pretty_name, kb_local_only_p);
}

okbc_node *handle_current_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    return okbc_current_kb();
}

okbc_node *handle_decontextualize(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *value;
    char *from_context;
    char *kb = NULL;

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "from-context"))) {
         from_context = ret;
    } else {
         r->status_line = "400 Required argment 'from-context' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_decontextualize(value, from_context, kb);
}

okbc_node *handle_delete_facet(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *facet;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_delete_facet(facet, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_delete_frame(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_delete_frame(frame, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_delete_slot(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *slot;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_delete_slot(slot, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_detach_facet(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *slot_type = key_own;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_detach_facet(frame, slot, facet, kb, slot_type, kb_local_only_p);

    return NULL;
}

okbc_node *handle_detach_slot(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *slot_type = key_own;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_detach_slot(frame, slot, kb, slot_type, kb_local_only_p);

    return NULL;
}

okbc_node *handle_enumerate_all_connections(request_rec *r, char *args[MAX_ARGS+1][2])
{
    return okbc_enumerate_all_connections();
}

okbc_node *handle_enumerate_ask(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *query;
    char *kb = NULL;
    char *reply_pattern = "query";
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   error_p = true;
    char *where = NULL;
    char *timeout = NULL;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "query"))) {
         query = ret;
    } else {
         r->status_line = "400 Required argment 'query' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "reply-pattern"))) {
        reply_pattern = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "where"))) {
        where = ret;
    }

    if ((ret = has_arg(args, "timeout"))) {
        timeout = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_ask(query, kb, reply_pattern, inference_level, number_of_values, error_p, where, timeout, value_selector, kb_local_only_p);
}

okbc_node *handle_enumerate_call_procedure(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *procedure;
    char *kb = NULL;
    char *arguments = NULL;

    if ((ret = has_arg(args, "procedure"))) {
         procedure = ret;
    } else {
         r->status_line = "400 Required argment 'procedure' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "arguments"))) {
        arguments = ret;
    }

    return okbc_enumerate_call_procedure(procedure, kb, arguments);
}

okbc_node *handle_enumerate_class_instances(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_class_instances(class, kb, inference_level, number_of_values, kb_local_only_p);
}

okbc_node *handle_enumerate_class_subclasses(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_class_subclasses(class, kb, inference_level, number_of_values, kb_local_only_p);
}

okbc_node *handle_enumerate_class_superclasses(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_class_superclasses(class, kb, inference_level, number_of_values, kb_local_only_p);
}

okbc_node *handle_enumerate_facet_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   number_of_values = 0;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_facet_values(frame, slot, facet, kb, inference_level, slot_type, number_of_values, value_selector, kb_local_only_p);
}

okbc_node *handle_enumerate_facet_values_in_detail(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   number_of_values = 0;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_facet_values_in_detail(frame, slot, facet, kb, inference_level, slot_type, number_of_values, value_selector, kb_local_only_p);
}

okbc_node *handle_enumerate_frame_slots(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_all;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_frame_slots(frame, kb, inference_level, slot_type, kb_local_only_p);
}

okbc_node *handle_enumerate_frames_matching(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *pattern;
    char *kb = NULL;
    int   wildcards_allowed_p = true;
    char *selector = key_all;
    int   force_case_insensitive_p = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "pattern"))) {
         pattern = ret;
    } else {
         r->status_line = "400 Required argment 'pattern' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "wildcards-allowed-p"))) {
        wildcards_allowed_p = btoi(ret);
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "force-case-insensitive-p"))) {
        force_case_insensitive_p = btoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_frames_matching(pattern, kb, wildcards_allowed_p, selector, force_case_insensitive_p, kb_local_only_p);
}

okbc_node *handle_enumerate_instance_types(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_instance_types(frame, kb, inference_level, number_of_values, kb_local_only_p);
}

okbc_node *handle_enumerate_kb_classes(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_system_default;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_kb_classes(kb, selector, kb_local_only_p);
}

okbc_node *handle_enumerate_kb_direct_children(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_enumerate_kb_direct_children(kb);
}

okbc_node *handle_enumerate_kb_direct_parents(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_enumerate_kb_direct_parents(kb);
}

okbc_node *handle_enumerate_kb_facets(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_system_default;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_kb_facets(kb, selector, kb_local_only_p);
}

okbc_node *handle_enumerate_kb_frames(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_kb_frames(kb, kb_local_only_p);
}

okbc_node *handle_enumerate_kb_individuals(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_system_default;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_kb_individuals(kb, selector, kb_local_only_p);
}

okbc_node *handle_enumerate_kb_roots(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_all;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_kb_roots(kb, selector, kb_local_only_p);
}

okbc_node *handle_enumerate_kb_slots(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_system_default;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_kb_slots(kb, selector, kb_local_only_p);
}

okbc_node *handle_enumerate_kb_types(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_enumerate_kb_types(connection);
}

okbc_node *handle_enumerate_kbs(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_enumerate_kbs(connection);
}

okbc_node *handle_enumerate_kbs_of_type(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb_type = NULL;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_enumerate_kbs_of_type(kb_type, connection);
}

okbc_node *handle_enumerate_list(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *list;

    if ((ret = has_arg(args, "list"))) {
         list = ret;
    } else {
         r->status_line = "400 Required argment 'list' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    return okbc_enumerate_list(list);
}

okbc_node *handle_enumerate_slot_facets(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_slot_facets(frame, slot, kb, inference_level, slot_type, kb_local_only_p);
}

okbc_node *handle_enumerate_slot_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   number_of_values = 0;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_slot_values(frame, slot, kb, inference_level, slot_type, number_of_values, value_selector, kb_local_only_p);
}

okbc_node *handle_enumerate_slot_values_in_detail(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   number_of_values = 0;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_enumerate_slot_values_in_detail(frame, slot, kb, inference_level, slot_type, number_of_values, value_selector, kb_local_only_p);
}

okbc_node *handle_eql_in_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *arg0;
    char *arg1;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "arg0"))) {
         arg0 = ret;
    } else {
         r->status_line = "400 Required argment 'arg0' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "arg1"))) {
         arg1 = ret;
    } else {
         r->status_line = "400 Required argment 'arg1' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_eql_in_kb(arg0, arg1, kb, kb_local_only_p);
}

okbc_node *handle_equal_in_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *arg0;
    char *arg1;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "arg0"))) {
         arg0 = ret;
    } else {
         r->status_line = "400 Required argment 'arg0' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "arg1"))) {
         arg1 = ret;
    } else {
         r->status_line = "400 Required argment 'arg1' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_equal_in_kb(arg0, arg1, kb, kb_local_only_p);
}

okbc_node *handle_equalp_in_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *arg0;
    char *arg1;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "arg0"))) {
         arg0 = ret;
    } else {
         r->status_line = "400 Required argment 'arg0' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "arg1"))) {
         arg1 = ret;
    } else {
         r->status_line = "400 Required argment 'arg1' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_equalp_in_kb(arg0, arg1, kb, kb_local_only_p);
}

okbc_node *handle_establish_connection(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *connection_type;
    char *initargs = NULL;

    if ((ret = has_arg(args, "connection-type"))) {
         connection_type = ret;
    } else {
         r->status_line = "400 Required argment 'connection-type' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "initargs"))) {
        initargs = ret;
    }

    return okbc_establish_connection(connection_type, initargs);
}

okbc_node *handle_expunge_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb_locator;
    char *kb_type = NULL;
    char *connection = "(local-connection)";
    int   error_p = true;

    if ((ret = has_arg(args, "kb-locator"))) {
         kb_locator = ret;
    } else {
         r->status_line = "400 Required argment 'kb-locator' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    okbc_expunge_kb(kb_locator, kb_type, connection, error_p);

    return NULL;
}

okbc_node *handle_facet_has_value_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_facet_has_value_p(frame, slot, facet, kb, inference_level, slot_type, value_selector, kb_local_only_p);
}

okbc_node *handle_facet_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_facet_p(thing, kb, kb_local_only_p);
}

okbc_node *handle_fetch(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *enumerator;
    int   number_of_values = 0;

    if ((ret = has_arg(args, "enumerator"))) {
         enumerator = ret;
    } else {
         r->status_line = "400 Required argment 'enumerator' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    return okbc_fetch(enumerator, number_of_values);
}

okbc_node *handle_find_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name_or_kb_or_kb_locator;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "name-or-kb-or-kb-locator"))) {
         name_or_kb_or_kb_locator = ret;
    } else {
         r->status_line = "400 Required argment 'name-or-kb-or-kb-locator' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_find_kb(name_or_kb_or_kb_locator, connection);
}

okbc_node *handle_find_kb_locator(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb_type = NULL;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_find_kb_locator(thing, kb_type, connection);
}

okbc_node *handle_find_kb_of_type(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name_or_kb;
    char *kb_type = NULL;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "name-or-kb"))) {
         name_or_kb = ret;
    } else {
         r->status_line = "400 Required argment 'name-or-kb' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_find_kb_of_type(name_or_kb, kb_type, connection);
}

okbc_node *handle_follow_slot_chain(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot_chain;
    char *kb = NULL;
    char *union_multiple_values = "true";
    char *inference_level = key_taxonomic;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot-chain"))) {
         slot_chain = ret;
    } else {
         r->status_line = "400 Required argment 'slot-chain' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "union-multiple-values"))) {
        union_multiple_values = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_follow_slot_chain(frame, slot_chain, kb, union_multiple_values, inference_level, value_selector, kb_local_only_p);
}

okbc_node *handle_frame_has_slot_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_frame_has_slot_p(frame, slot, kb, inference_level, slot_type, kb_local_only_p);
}

okbc_node *handle_frame_in_kb_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_frame_in_kb_p(thing, kb, kb_local_only_p);
}

okbc_node *handle_free(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *enumerator;

    if ((ret = has_arg(args, "enumerator"))) {
         enumerator = ret;
    } else {
         r->status_line = "400 Required argment 'enumerator' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    okbc_free(enumerator);

    return NULL;
}

okbc_node *handle_frs_independent_frame_handle(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_frs_independent_frame_handle(frame, kb, kb_local_only_p);
}

okbc_node *handle_frs_name(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb_type = NULL;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_frs_name(kb_type, connection);
}

okbc_node *handle_get_behavior_supported_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *behavior;
    char *kb = NULL;

    if ((ret = has_arg(args, "behavior"))) {
         behavior = ret;
    } else {
         r->status_line = "400 Required argment 'behavior' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_get_behavior_supported_values(behavior, kb);
}

okbc_node *handle_get_behavior_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *behavior;
    char *kb = NULL;

    if ((ret = has_arg(args, "behavior"))) {
         behavior = ret;
    } else {
         r->status_line = "400 Required argment 'behavior' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_get_behavior_values(behavior, kb);
}

okbc_node *handle_get_class_instances(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_class_instances(class, kb, inference_level, number_of_values, kb_local_only_p);
}

okbc_node *handle_get_class_subclasses(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_class_subclasses(class, kb, inference_level, number_of_values, kb_local_only_p);
}

okbc_node *handle_get_class_superclasses(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_class_superclasses(class, kb, inference_level, number_of_values, kb_local_only_p);
}

okbc_node *handle_get_classes_in_domain_of(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *slot;
    char *kb = NULL;
    char *frame_attachment = NULL;
    char *inference_level = key_taxonomic;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "frame-attachment"))) {
        frame_attachment = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_classes_in_domain_of(slot, kb, frame_attachment, inference_level, kb_local_only_p);
}

okbc_node *handle_get_facet_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_facet_value(frame, slot, facet, kb, inference_level, slot_type, value_selector, kb_local_only_p);
}

okbc_node *handle_get_facet_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   number_of_values = 0;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_facet_values(frame, slot, facet, kb, inference_level, slot_type, number_of_values, value_selector, kb_local_only_p);
}

okbc_node *handle_get_facet_values_in_detail(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   number_of_values = 0;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_facet_values_in_detail(frame, slot, facet, kb, inference_level, slot_type, number_of_values, value_selector, kb_local_only_p);
}

okbc_node *handle_get_frame_details(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frame_details(frame, kb, inference_level, number_of_values, kb_local_only_p);
}

okbc_node *handle_get_frame_handle(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frame_handle(frame, kb, kb_local_only_p);
}

okbc_node *handle_get_frame_in_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   error_p = true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frame_in_kb(thing, kb, error_p, kb_local_only_p);
}

okbc_node *handle_get_frame_name(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frame_name(frame, kb, kb_local_only_p);
}

okbc_node *handle_get_frame_pretty_name(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frame_pretty_name(frame, kb, kb_local_only_p);
}

okbc_node *handle_get_frame_sentences(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    int   number_of_values = 0;
    int   okbc_sentences_p = true;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "okbc-sentences-p"))) {
        okbc_sentences_p = btoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frame_sentences(frame, kb, number_of_values, okbc_sentences_p, value_selector, kb_local_only_p);
}

okbc_node *handle_get_frame_slots(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_all;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frame_slots(frame, kb, inference_level, slot_type, kb_local_only_p);
}

okbc_node *handle_get_frame_type(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frame_type(thing, kb, kb_local_only_p);
}

okbc_node *handle_get_frames_matching(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *pattern;
    char *kb = NULL;
    int   wildcards_allowed_p = true;
    char *selector = key_all;
    int   force_case_insensitive_p = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "pattern"))) {
         pattern = ret;
    } else {
         r->status_line = "400 Required argment 'pattern' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "wildcards-allowed-p"))) {
        wildcards_allowed_p = btoi(ret);
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "force-case-insensitive-p"))) {
        force_case_insensitive_p = btoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frames_matching(pattern, kb, wildcards_allowed_p, selector, force_case_insensitive_p, kb_local_only_p);
}

okbc_node *handle_get_frames_with_facet_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *slot;
    char *facet;
    char *value;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frames_with_facet_value(slot, facet, value, kb, inference_level, slot_type, value_selector, kb_local_only_p);
}

okbc_node *handle_get_frames_with_slot_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *slot;
    char *value;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_frames_with_slot_value(slot, value, kb, inference_level, slot_type, value_selector, kb_local_only_p);
}

okbc_node *handle_get_instance_types(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_instance_types(frame, kb, inference_level, number_of_values, kb_local_only_p);
}

okbc_node *handle_get_kb_behaviors(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb_type_or_kb = "(current-kb)";
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "kb-type-or-kb"))) {
        kb_type_or_kb = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_get_kb_behaviors(kb_type_or_kb, connection);
}

okbc_node *handle_get_kb_classes(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_system_default;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_kb_classes(kb, selector, kb_local_only_p);
}

okbc_node *handle_get_kb_direct_children(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_get_kb_direct_children(kb);
}

okbc_node *handle_get_kb_direct_parents(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_get_kb_direct_parents(kb);
}

okbc_node *handle_get_kb_facets(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_system_default;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_kb_facets(kb, selector, kb_local_only_p);
}

okbc_node *handle_get_kb_frames(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_kb_frames(kb, kb_local_only_p);
}

okbc_node *handle_get_kb_individuals(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_system_default;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_kb_individuals(kb, selector, kb_local_only_p);
}

okbc_node *handle_get_kb_roots(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_all;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_kb_roots(kb, selector, kb_local_only_p);
}

okbc_node *handle_get_kb_slots(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    char *selector = key_system_default;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "selector"))) {
        selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_kb_slots(kb, selector, kb_local_only_p);
}

okbc_node *handle_get_kb_type(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_get_kb_type(thing, connection);
}

okbc_node *handle_get_kb_types(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_get_kb_types(connection);
}

okbc_node *handle_get_kbs(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_get_kbs(connection);
}

okbc_node *handle_get_kbs_of_type(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb_type = NULL;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_get_kbs_of_type(kb_type, connection);
}

okbc_node *handle_get_procedure(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name;
    char *kb = NULL;

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_get_procedure(name, kb);
}

okbc_node *handle_get_slot_facets(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_slot_facets(frame, slot, kb, inference_level, slot_type, kb_local_only_p);
}

okbc_node *handle_get_slot_type(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_slot_type(frame, slot, kb, inference_level, kb_local_only_p);
}

okbc_node *handle_get_slot_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_slot_value(frame, slot, kb, inference_level, slot_type, value_selector, kb_local_only_p);
}

okbc_node *handle_get_slot_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   number_of_values = 0;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_slot_values(frame, slot, kb, inference_level, slot_type, number_of_values, value_selector, kb_local_only_p);
}

okbc_node *handle_get_slot_values_in_detail(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   number_of_values = 0;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_get_slot_values_in_detail(frame, slot, kb, inference_level, slot_type, number_of_values, value_selector, kb_local_only_p);
}

okbc_node *handle_goto_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb;

    if ((ret = has_arg(args, "kb"))) {
         kb = ret;
    } else {
         r->status_line = "400 Required argment 'kb' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    okbc_goto_kb(kb);

    return NULL;
}

okbc_node *handle_has_more(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *enumerator;

    if ((ret = has_arg(args, "enumerator"))) {
         enumerator = ret;
    } else {
         r->status_line = "400 Required argment 'enumerator' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    return okbc_has_more(enumerator);
}

okbc_node *handle_individual_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_individual_p(thing, kb, kb_local_only_p);
}

okbc_node *handle_instance_of_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *class;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_instance_of_p(thing, class, kb, inference_level, kb_local_only_p);
}

okbc_node *handle_kb_modified_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_kb_modified_p(kb);
}

okbc_node *handle_kb_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    return okbc_kb_p(thing);
}

okbc_node *handle_local_connection(request_rec *r, char *args[MAX_ARGS+1][2])
{
    return okbc_local_connection();
}

okbc_node *handle_member_behavior_values_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *behavior;
    char *value;
    char *kb = NULL;

    if ((ret = has_arg(args, "behavior"))) {
         behavior = ret;
    } else {
         r->status_line = "400 Required argment 'behavior' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    return okbc_member_behavior_values_p(behavior, value, kb);
}

okbc_node *handle_member_facet_value_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *value;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *test = key_equal;
    char *slot_type = key_own;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "test"))) {
        test = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_member_facet_value_p(frame, slot, facet, value, kb, inference_level, test, slot_type, value_selector, kb_local_only_p);
}

okbc_node *handle_member_slot_value_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *value;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *test = key_equal;
    char *slot_type = key_own;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "test"))) {
        test = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_member_slot_value_p(frame, slot, value, kb, inference_level, test, slot_type, value_selector, kb_local_only_p);
}

okbc_node *handle_meta_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *connection = "(local-connection)";

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    return okbc_meta_kb(connection);
}

okbc_node *handle_next(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *enumerator;

    if ((ret = has_arg(args, "enumerator"))) {
         enumerator = ret;
    } else {
         r->status_line = "400 Required argment 'enumerator' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    return okbc_next(enumerator);
}

okbc_node *handle_okbc_condition_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    return okbc_okbc_condition_p(thing);
}

okbc_node *handle_open_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb_locator;
    char *kb_type = NULL;
    char *connection = "(local-connection)";
    int   error_p = true;

    if ((ret = has_arg(args, "kb-locator"))) {
         kb_locator = ret;
    } else {
         r->status_line = "400 Required argment 'kb-locator' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    return okbc_open_kb(kb_locator, kb_type, connection, error_p);
}

okbc_node *handle_openable_kbs(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb_type = NULL;
    char *connection = "(local-connection)";
    char *place = NULL;

    if ((ret = has_arg(args, "kb-type"))) {
        kb_type = ret;
    }

    if ((ret = has_arg(args, "connection"))) {
        connection = ret;
    }

    if ((ret = has_arg(args, "place"))) {
        place = ret;
    }

    return okbc_openable_kbs(kb_type, connection, place);
}

okbc_node *handle_prefetch(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *enumerator;
    int   number_of_values = 0;
    char *increment = NULL;

    if ((ret = has_arg(args, "enumerator"))) {
         enumerator = ret;
    } else {
         r->status_line = "400 Required argment 'enumerator' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "increment"))) {
        increment = ret;
    }

    okbc_prefetch(enumerator, number_of_values, increment);

    return NULL;
}

okbc_node *handle_primitive_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_primitive_p(class, kb, kb_local_only_p);
}

okbc_node *handle_print_frame(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *kb = NULL;
    char *slots = key_filled;
    char *facets = key_filled;
    char *stream = "true";
    char *inference_level = key_taxonomic;
    int   number_of_values = 0;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slots"))) {
        slots = ret;
    }

    if ((ret = has_arg(args, "facets"))) {
        facets = ret;
    }

    if ((ret = has_arg(args, "stream"))) {
        stream = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "number-of-values"))) {
        number_of_values = atoi(ret);
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_print_frame(frame, kb, slots, facets, stream, inference_level, number_of_values, value_selector, kb_local_only_p);
}

okbc_node *handle_procedure_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    return okbc_procedure_p(thing);
}

okbc_node *handle_put_behavior_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *behavior;
    char *values;
    char *kb = NULL;

    if ((ret = has_arg(args, "behavior"))) {
         behavior = ret;
    } else {
         r->status_line = "400 Required argment 'behavior' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "values"))) {
         values = ret;
    } else {
         r->status_line = "400 Required argment 'values' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    okbc_put_behavior_values(behavior, values, kb);

    return NULL;
}

okbc_node *handle_put_class_superclasses(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *new_superclasses;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-superclasses"))) {
         new_superclasses = ret;
    } else {
         r->status_line = "400 Required argment 'new-superclasses' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_put_class_superclasses(class, new_superclasses, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_put_facet_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *value;
    char *kb = NULL;
    char *slot_type = key_own;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_put_facet_value(frame, slot, facet, value, kb, slot_type, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_put_facet_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *values;
    char *kb = NULL;
    char *slot_type = key_own;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "values"))) {
         values = ret;
    } else {
         r->status_line = "400 Required argment 'values' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_put_facet_values(frame, slot, facet, values, kb, slot_type, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_put_frame_details(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *details;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "details"))) {
         details = ret;
    } else {
         r->status_line = "400 Required argment 'details' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_put_frame_details(frame, details, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_put_frame_name(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *new_name;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-name"))) {
         new_name = ret;
    } else {
         r->status_line = "400 Required argment 'new-name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_put_frame_name(frame, new_name, kb, kb_local_only_p);
}

okbc_node *handle_put_frame_pretty_name(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *name;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_put_frame_pretty_name(frame, name, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_put_instance_types(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *new_types;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-types"))) {
         new_types = ret;
    } else {
         r->status_line = "400 Required argment 'new-types' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_put_instance_types(frame, new_types, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_put_slot_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *value;
    char *kb = NULL;
    char *slot_type = key_own;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_put_slot_value(frame, slot, value, kb, slot_type, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_put_slot_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *values;
    char *kb = NULL;
    char *slot_type = key_own;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "values"))) {
         values = ret;
    } else {
         r->status_line = "400 Required argment 'values' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_put_slot_values(frame, slot, values, kb, slot_type, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_register_procedure(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name;
    char *procedure;
    char *kb = NULL;

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "procedure"))) {
         procedure = ret;
    } else {
         r->status_line = "400 Required argment 'procedure' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    okbc_register_procedure(name, procedure, kb);

    return NULL;
}

okbc_node *handle_remove_class_superclass(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *superclass_to_remove;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "superclass-to-remove"))) {
         superclass_to_remove = ret;
    } else {
         r->status_line = "400 Required argment 'superclass-to-remove' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_remove_class_superclass(class, superclass_to_remove, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_remove_facet_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *value;
    char *kb = NULL;
    char *test = key_equal;
    char *slot_type = key_own;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "test"))) {
        test = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_remove_facet_value(frame, slot, facet, value, kb, test, slot_type, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_remove_instance_type(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *type_to_remove;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "type-to-remove"))) {
         type_to_remove = ret;
    } else {
         r->status_line = "400 Required argment 'type-to-remove' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_remove_instance_type(frame, type_to_remove, kb, kb_local_only_p);

    return NULL;
}

okbc_node *handle_remove_local_facet_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *slot_type = key_own;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_remove_local_facet_values(frame, slot, facet, kb, slot_type, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_remove_local_slot_values(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *slot_type = key_own;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_remove_local_slot_values(frame, slot, kb, slot_type, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_remove_slot_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *value;
    char *kb = NULL;
    char *test = key_equal;
    char *slot_type = key_own;
    char *index = key_all;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "test"))) {
        test = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "index"))) {
        index = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_remove_slot_value(frame, slot, value, kb, test, slot_type, index, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_rename_facet(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *facet;
    char *new_name;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-name"))) {
         new_name = ret;
    } else {
         r->status_line = "400 Required argment 'new-name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_rename_facet(facet, new_name, kb, kb_local_only_p);
}

okbc_node *handle_rename_slot(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *slot;
    char *new_name;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-name"))) {
         new_name = ret;
    } else {
         r->status_line = "400 Required argment 'new-name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_rename_slot(slot, new_name, kb, kb_local_only_p);
}

okbc_node *handle_replace_facet_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *old_value;
    char *new_value;
    char *kb = NULL;
    char *test = key_equal;
    char *slot_type = key_own;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "old-value"))) {
         old_value = ret;
    } else {
         r->status_line = "400 Required argment 'old-value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-value"))) {
         new_value = ret;
    } else {
         r->status_line = "400 Required argment 'new-value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "test"))) {
        test = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_replace_facet_value(frame, slot, facet, old_value, new_value, kb, test, slot_type, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_replace_slot_value(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *old_value;
    char *new_value;
    char *kb = NULL;
    char *test = key_equal;
    char *slot_type = key_own;
    char *index = key_all;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "old-value"))) {
         old_value = ret;
    } else {
         r->status_line = "400 Required argment 'old-value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "new-value"))) {
         new_value = ret;
    } else {
         r->status_line = "400 Required argment 'new-value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "test"))) {
        test = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "index"))) {
        index = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_replace_slot_value(frame, slot, old_value, new_value, kb, test, slot_type, index, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_revert_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    int   error_p = true;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    return okbc_revert_kb(kb, error_p);
}

okbc_node *handle_save_kb(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *kb = NULL;
    int   error_p = true;

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "error-p"))) {
        error_p = btoi(ret);
    }

    return okbc_save_kb(kb, error_p);
}

okbc_node *handle_save_kb_as(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *new_name_or_locator;
    char *kb = NULL;

    if ((ret = has_arg(args, "new-name-or-locator"))) {
         new_name_or_locator = ret;
    } else {
         r->status_line = "400 Required argment 'new-name-or-locator' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    okbc_save_kb_as(new_name_or_locator, kb);

    return NULL;
}

okbc_node *handle_slot_has_facet_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *facet;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "facet"))) {
         facet = ret;
    } else {
         r->status_line = "400 Required argment 'facet' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_slot_has_facet_p(frame, slot, facet, kb, inference_level, slot_type, kb_local_only_p);
}

okbc_node *handle_slot_has_value_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *frame;
    char *slot;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    char *slot_type = key_own;
    char *value_selector = key_either;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "frame"))) {
         frame = ret;
    } else {
         r->status_line = "400 Required argment 'frame' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "slot"))) {
         slot = ret;
    } else {
         r->status_line = "400 Required argment 'slot' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "slot-type"))) {
        slot_type = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_slot_has_value_p(frame, slot, kb, inference_level, slot_type, value_selector, kb_local_only_p);
}

okbc_node *handle_slot_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *thing;
    char *kb = NULL;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_slot_p(thing, kb, kb_local_only_p);
}

okbc_node *handle_subclass_of_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *subclass;
    char *superclass;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "subclass"))) {
         subclass = ret;
    } else {
         r->status_line = "400 Required argment 'subclass' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "superclass"))) {
         superclass = ret;
    } else {
         r->status_line = "400 Required argment 'superclass' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_subclass_of_p(subclass, superclass, kb, inference_level, kb_local_only_p);
}

okbc_node *handle_superclass_of_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *superclass;
    char *subclass;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "superclass"))) {
         superclass = ret;
    } else {
         r->status_line = "400 Required argment 'superclass' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "subclass"))) {
         subclass = ret;
    } else {
         r->status_line = "400 Required argment 'subclass' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_superclass_of_p(superclass, subclass, kb, inference_level, kb_local_only_p);
}

okbc_node *handle_tell(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *sentence;
    char *kb = NULL;
    char *frame = NULL;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "sentence"))) {
         sentence = ret;
    } else {
         r->status_line = "400 Required argment 'sentence' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "frame"))) {
        frame = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    okbc_tell(sentence, kb, frame, value_selector, kb_local_only_p);

    return NULL;
}

okbc_node *handle_tellable(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *sentence;
    char *kb = NULL;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "sentence"))) {
         sentence = ret;
    } else {
         r->status_line = "400 Required argment 'sentence' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_tellable(sentence, kb, value_selector, kb_local_only_p);
}

okbc_node *handle_type_of_p(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *class;
    char *thing;
    char *kb = NULL;
    char *inference_level = key_taxonomic;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "class"))) {
         class = ret;
    } else {
         r->status_line = "400 Required argment 'class' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "thing"))) {
         thing = ret;
    } else {
         r->status_line = "400 Required argment 'thing' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "inference-level"))) {
        inference_level = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_type_of_p(class, thing, kb, inference_level, kb_local_only_p);
}

okbc_node *handle_unregister_procedure(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *name;
    char *kb = NULL;

    if ((ret = has_arg(args, "name"))) {
         name = ret;
    } else {
         r->status_line = "400 Required argment 'name' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    okbc_unregister_procedure(name, kb);

    return NULL;
}

okbc_node *handle_untell(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *sentence;
    char *kb = NULL;
    char *frame = NULL;
    char *value_selector = key_known_true;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "sentence"))) {
         sentence = ret;
    } else {
         r->status_line = "400 Required argment 'sentence' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "frame"))) {
        frame = ret;
    }

    if ((ret = has_arg(args, "value-selector"))) {
        value_selector = ret;
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_untell(sentence, kb, frame, value_selector, kb_local_only_p);
}

okbc_node *handle_value_as_string(request_rec *r, char *args[MAX_ARGS+1][2])
{
    char *ret;
    char *value;
    char *kb = NULL;
    char *purpose = NULL;
    int   pretty_p = 0;
    int   kb_local_only_p = 0;

    if ((ret = has_arg(args, "value"))) {
         value = ret;
    } else {
         r->status_line = "400 Required argment 'value' missing";
         r->status = HTTP_BAD_REQUEST;
         return NULL;
    }

    if ((ret = has_arg(args, "kb"))) {
        kb = ret;
    }

    if ((ret = has_arg(args, "purpose"))) {
        purpose = ret;
    }

    if ((ret = has_arg(args, "pretty-p"))) {
        pretty_p = btoi(ret);
    }

    if ((ret = has_arg(args, "kb-local-only-p"))) {
        kb_local_only_p = btoi(ret);
    }

    return okbc_value_as_string(value, kb, purpose, pretty_p, kb_local_only_p);
}

