#ifndef HANDLERS_H
#define HANDLERS_H

#include "mod_3store.h"

static inline char *has_arg(char *args[MAX_ARGS + 1][2], const char *cmp)
{
    unsigned int i;

    for (i = 0; args[i][0]; i++) {
	if (!strcmp(cmp, args[i][0])) {
	    return args[i][1];
	}
    }
    return NULL;
}

okbc_node *handle_add_class_superclass(request_rec * r,
				       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_add_facet_value(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_add_instance_type(request_rec * r,
				    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_add_slot_value(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_all_connections(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_allocate_frame_handle(request_rec * r,
					char *args[MAX_ARGS + 1][2]);
okbc_node *handle_ask(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_askable(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_attach_facet(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_attach_slot(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_call_procedure(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_class_p(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_close_connection(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_close_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_coerce_to_class(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_coerce_to_facet(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_coerce_to_frame(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_coerce_to_individual(request_rec * r,
				       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_coerce_to_kb_value(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_coerce_to_slot(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_coercible_to_frame_p(request_rec * r,
				       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_connection_p(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_continuable_error_p(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_copy_frame(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_copy_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_create_class(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_create_facet(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_create_frame(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_create_individual(request_rec * r,
				    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_create_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_create_kb_locator(request_rec * r,
				    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_create_procedure(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_create_slot(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_current_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_decontextualize(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_delete_facet(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_delete_frame(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_delete_slot(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_detach_facet(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_detach_slot(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_all_connections(request_rec * r,
					    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_ask(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_call_procedure(request_rec * r,
					   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_class_instances(request_rec * r,
					    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_class_subclasses(request_rec * r,
					     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_class_superclasses(request_rec * r,
					       char *args[MAX_ARGS +
							  1][2]);
okbc_node *handle_enumerate_facet_values(request_rec * r,
					 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_facet_values_in_detail(request_rec * r,
						   char *args[MAX_ARGS +
							      1][2]);
okbc_node *handle_enumerate_frame_slots(request_rec * r,
					char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_frames_matching(request_rec * r,
					    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_instance_types(request_rec * r,
					   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kb_classes(request_rec * r,
				       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kb_direct_children(request_rec * r,
					       char *args[MAX_ARGS +
							  1][2]);
okbc_node *handle_enumerate_kb_direct_parents(request_rec * r,
					      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kb_facets(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kb_frames(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kb_individuals(request_rec * r,
					   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kb_roots(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kb_slots(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kb_types(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kbs(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_kbs_of_type(request_rec * r,
					char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_list(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_slot_facets(request_rec * r,
					char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_slot_values(request_rec * r,
					char *args[MAX_ARGS + 1][2]);
okbc_node *handle_enumerate_slot_values_in_detail(request_rec * r,
						  char *args[MAX_ARGS +
							     1][2]);
okbc_node *handle_eql_in_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_equal_in_kb(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_equalp_in_kb(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_establish_connection(request_rec * r,
				       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_expunge_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_facet_has_value_p(request_rec * r,
				    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_facet_p(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_fetch(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_find_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_find_kb_locator(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_find_kb_of_type(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_follow_slot_chain(request_rec * r,
				    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_frame_has_slot_p(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_frame_in_kb_p(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_free(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_frs_independent_frame_handle(request_rec * r,
					       char *args[MAX_ARGS +
							  1][2]);
okbc_node *handle_frs_name(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_behavior_supported_values(request_rec * r,
						char *args[MAX_ARGS +
							   1][2]);
okbc_node *handle_get_behavior_values(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_class_instances(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_class_subclasses(request_rec * r,
				       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_class_superclasses(request_rec * r,
					 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_classes_in_domain_of(request_rec * r,
					   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_facet_value(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_facet_values(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_facet_values_in_detail(request_rec * r,
					     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frame_details(request_rec * r,
				    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frame_handle(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frame_in_kb(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frame_name(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frame_pretty_name(request_rec * r,
					char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frame_sentences(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frame_slots(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frame_type(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frames_matching(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frames_with_facet_value(request_rec * r,
					      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_frames_with_slot_value(request_rec * r,
					     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_instance_types(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_behaviors(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_classes(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_direct_children(request_rec * r,
					 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_direct_parents(request_rec * r,
					char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_facets(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_frames(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_individuals(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_roots(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_slots(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_type(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kb_types(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kbs(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_kbs_of_type(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_procedure(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_slot_facets(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_slot_type(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_slot_value(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_slot_values(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_get_slot_values_in_detail(request_rec * r,
					    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_goto_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_has_more(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_individual_p(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_instance_of_p(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_kb_modified_p(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_kb_p(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_local_connection(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_member_behavior_values_p(request_rec * r,
					   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_member_facet_value_p(request_rec * r,
				       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_member_slot_value_p(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_meta_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_next(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_okbc_condition_p(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_open_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_openable_kbs(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_prefetch(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_primitive_p(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_print_frame(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_procedure_p(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_behavior_values(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_class_superclasses(request_rec * r,
					 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_facet_value(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_facet_values(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_frame_details(request_rec * r,
				    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_frame_name(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_frame_pretty_name(request_rec * r,
					char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_instance_types(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_slot_value(request_rec * r,
				 char *args[MAX_ARGS + 1][2]);
okbc_node *handle_put_slot_values(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_register_procedure(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_remove_class_superclass(request_rec * r,
					  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_remove_facet_value(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_remove_instance_type(request_rec * r,
				       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_remove_local_facet_values(request_rec * r,
					    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_remove_local_slot_values(request_rec * r,
					   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_remove_slot_value(request_rec * r,
				    char *args[MAX_ARGS + 1][2]);
okbc_node *handle_rename_facet(request_rec * r,
			       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_rename_slot(request_rec * r,
			      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_replace_facet_value(request_rec * r,
				      char *args[MAX_ARGS + 1][2]);
okbc_node *handle_replace_slot_value(request_rec * r,
				     char *args[MAX_ARGS + 1][2]);
okbc_node *handle_revert_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_save_kb(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_save_kb_as(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_slot_has_facet_p(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_slot_has_value_p(request_rec * r,
				   char *args[MAX_ARGS + 1][2]);
okbc_node *handle_slot_p(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_subclass_of_p(request_rec * r,
				char *args[MAX_ARGS + 1][2]);
okbc_node *handle_superclass_of_p(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);
okbc_node *handle_tell(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_tellable(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_type_of_p(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_unregister_procedure(request_rec * r,
				       char *args[MAX_ARGS + 1][2]);
okbc_node *handle_untell(request_rec * r, char *args[MAX_ARGS + 1][2]);
okbc_node *handle_value_as_string(request_rec * r,
				  char *args[MAX_ARGS + 1][2]);

#endif
