#ifndef HASH_TABLE_H
#define HASH_TABLE_H

#include <httpd.h>
#include <okbc.h>

#include "mod_3store.h"

#define HASH_SIZE 1024

typedef struct {
	char *name;
	okbc_node *(*func)(request_rec *r, char *args[MAX_ARGS+1][2]);
} hash_ent;

extern hash_ent hash_table[];

void init_hash_table();

static inline int hash_func(const char *s) {
	int i;
	int total = 0;

	for (i=0; s[i]; i++) {
		total += s[i] * (i + 1) * (i + 1);
	}

	return total & (HASH_SIZE - 1);
}

#endif
