/*
 *  Copyright (C) 2002 Steve Harris, ECS, University of Southampton
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  $Id: uri_escape.c,v 1.4 2002/12/18 12:06:23 theno23 Exp $
 */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

char *uri_unescape(const char *str)
{
	char *ret;
	const char *iptr;
	char **val = NULL;
	char *optr;
	char hex[3];

	hex[2] = '\0';
	ret = malloc(strlen(str) + 1);
	for (iptr = str, optr = ret; *iptr; iptr++, optr++) {
		switch (*iptr) {
			case '+':
				*optr = ' ';
				break;
			case '%':
				strncpy(hex, iptr+1, 2);
				*optr = (char)strtol(hex, val, 16);
				iptr += 2;
				break;
			default:
				*optr = *iptr;
				break;
		}
	}
	*optr = '\0';

	return ret;
}

char *xml_escape(const char *str)
{
	int out_length;
	char *iptr, *optr;
	char *ret;

	if (!str) {
		return NULL;
	}

	out_length = strlen(str);
	for (iptr = (char *)str; *iptr; iptr++) {
		if (strchr("&<>\"'", *iptr)) {
			out_length += 5;
		}
	}
	ret = malloc(out_length + 1);
	for (iptr = (char *)str, optr = ret; *iptr; iptr++, optr++) {
		if (strchr("&<>\"'", *iptr)) { // fixme
			sprintf(optr, "&#x%02x;", (int)*iptr);
			optr += 5;
		} else {
			*optr = *iptr;
		}
	}
	*optr = '\0';

	return ret;
}
