#include "okbc_types.h"

okbc_node *okbc_create_class(const char *name, const char *kb,
			     const char *direct_types,
			     const char *direct_superclasses,
			     int primitive_p, const char *doc,
			     const char *template_slots,
			     const char *template_facets,
			     const char *own_slots, const char *own_facets,
			     const char *handle, const char *pretty_name,
			     int kb_local_only_p);

okbc_node *okbc_create_facet(const char *name, const char *kb,
			     const char *frame_or_nil,
			     const char *slot_or_nil,
			     const char *slot_type,
			     const char *direct_types, const char *doc,
			     const char *own_slots, const char *own_facets,
			     const char *handle, const char *pretty_name,
			     int kb_local_only_p);

okbc_node *okbc_create_frame(const char *name, const char *frame_type,
			     const char *kb, const char *direct_types,
			     const char *direct_superclasses,
			     const char *doc, const char *template_slots,
			     const char *template_facets,
			     const char *own_slots, const char *own_facets,
			     int primitive_p, const char *handle,
			     const char *pretty_name, int kb_local_only_p);

okbc_node *okbc_create_individual(const char *name, const char *kb,
				  const char *direct_types,
				  const char *doc, const char *own_slots,
				  const char *own_facets,
				  const char *handle,
				  const char *pretty_name,
				  int kb_local_only_p);

okbc_node *okbc_create_kb(const char *name, const char *kb_type,
			  const char *kb_locator, const char *initargs,
			  const char *connection);

okbc_node *okbc_create_kb_locator(const char *thing, const char *kb_type,
				  const char *connection);

okbc_node *okbc_create_procedure(const char *kb, const char *arguments,
				 const char *body,
				 const char *environment);

okbc_node *okbc_create_slot(const char *name, const char *kb,
			    const char *frame_or_nil,
			    const char *slot_type,
			    const char *direct_types, const char *doc,
			    const char *own_slots, const char *own_facets,
			    const char *handle, const char *pretty_name,
			    int kb_local_only_p);
