#include "okbc_types.h"

okbc_node *okbc_enumerate_all_connections();

okbc_node *okbc_enumerate_ask(const char *query, const char *kb,
			      const char *reply_pattern,
			      const char *inference_level,
			      int number_of_values, int error_p,
			      const char *where, const char *timeout,
			      const char *value_selector,
			      int kb_local_only_p);

okbc_node *okbc_enumerate_call_procedure(const char *procedure,
					 const char *kb,
					 const char *arguments);

okbc_node *okbc_enumerate_class_instances(const char *class,
					  const char *kb,
					  const char *inference_level,
					  int number_of_values,
					  int kb_local_only_p);

okbc_node *okbc_enumerate_class_subclasses(const char *class,
					   const char *kb,
					   const char *inference_level,
					   int number_of_values,
					   int kb_local_only_p);

okbc_node *okbc_enumerate_class_superclasses(const char *class,
					     const char *kb,
					     const char *inference_level,
					     int number_of_values,
					     int kb_local_only_p);

okbc_node *okbc_enumerate_facet_values(const char *frame, const char *slot,
				       const char *facet, const char *kb,
				       const char *inference_level,
				       const char *slot_type,
				       int number_of_values,
				       const char *value_selector,
				       int kb_local_only_p);

okbc_node *okbc_enumerate_facet_values_in_detail(const char *frame,
						 const char *slot,
						 const char *facet,
						 const char *kb,
						 const char *inference_level,
						 const char *slot_type,
						 int number_of_values,
						 const char
						 *value_selector,
						 int kb_local_only_p);

okbc_node *okbc_enumerate_frame_slots(const char *frame, const char *kb,
				      const char *inference_level,
				      const char *slot_type,
				      int kb_local_only_p);

okbc_node *okbc_enumerate_frames_matching(const char *pattern,
					  const char *kb,
					  int wildcards_allowed_p,
					  const char *selector,
					  int force_case_insensitive_p,
					  int kb_local_only_p);

okbc_node *okbc_enumerate_instance_types(const char *frame, const char *kb,
					 const char *inference_level,
					 int number_of_values,
					 int kb_local_only_p);

okbc_node *okbc_enumerate_kb_classes(const char *kb, const char *selector,
				     int kb_local_only_p);

okbc_node *okbc_enumerate_kb_direct_children(const char *kb);

okbc_node *okbc_enumerate_kb_direct_parents(const char *kb);

okbc_node *okbc_enumerate_kb_facets(const char *kb, const char *selector,
				    int kb_local_only_p);

okbc_node *okbc_enumerate_kb_frames(const char *kb, int kb_local_only_p);

okbc_node *okbc_enumerate_kb_individuals(const char *kb,
					 const char *selector,
					 int kb_local_only_p);

okbc_node *okbc_enumerate_kb_roots(const char *kb, const char *selector,
				   int kb_local_only_p);

okbc_node *okbc_enumerate_kb_slots(const char *kb, const char *selector,
				   int kb_local_only_p);

okbc_node *okbc_enumerate_kb_types(const char *connection);

okbc_node *okbc_enumerate_kbs(const char *connection);

okbc_node *okbc_enumerate_kbs_of_type(const char *kb_type,
				      const char *connection);

okbc_node *okbc_enumerate_list(const char *list);

okbc_node *okbc_enumerate_slot_facets(const char *frame, const char *slot,
				      const char *kb,
				      const char *inference_level,
				      const char *slot_type,
				      int kb_local_only_p);

okbc_node *okbc_enumerate_slot_values(const char *frame, const char *slot,
				      const char *kb,
				      const char *inference_level,
				      const char *slot_type,
				      int number_of_values,
				      const char *value_selector,
				      int kb_local_only_p);

okbc_node *okbc_enumerate_slot_values_in_detail(const char *frame,
						const char *slot,
						const char *kb,
						const char
						*inference_level,
						const char *slot_type,
						int number_of_values,
						const char *value_selector,
						int kb_local_only_p);
