#include "okbc_types.h"

okbc_node *okbc_get_behavior_supported_values(const char *behavior,
					      const char *kb);

okbc_node *okbc_get_behavior_values(const char *behavior, const char *kb);

okbc_node *okbc_get_class_instances(const char *class, const char *kb,
				    const char *inference_level,
				    int number_of_values,
				    int kb_local_only_p);

okbc_node *okbc_get_class_subclasses(const char *class, const char *kb,
				     const char *inference_level,
				     int number_of_values,
				     int kb_local_only_p);

okbc_node *okbc_get_class_superclasses(const char *class, const char *kb,
				       const char *inference_level,
				       int number_of_values,
				       int kb_local_only_p);

okbc_node *okbc_get_classes_in_domain_of(const char *slot, const char *kb,
					 const char *frame_attachment,
					 const char *inference_level,
					 int kb_local_only_p);

okbc_node *okbc_get_facet_value(const char *frame, const char *slot,
				const char *facet, const char *kb,
				const char *inference_level,
				const char *slot_type,
				const char *value_selector,
				int kb_local_only_p);

okbc_node *okbc_get_facet_values(const char *frame, const char *slot,
				 const char *facet, const char *kb,
				 const char *inference_level,
				 const char *slot_type,
				 int number_of_values,
				 const char *value_selector,
				 int kb_local_only_p);

okbc_node *okbc_get_facet_values_in_detail(const char *frame,
					   const char *slot,
					   const char *facet,
					   const char *kb,
					   const char *inference_level,
					   const char *slot_type,
					   int number_of_values,
					   const char *value_selector,
					   int kb_local_only_p);

okbc_node *okbc_get_frame_details(const char *frame, const char *kb,
				  const char *inference_level,
				  int number_of_values,
				  int kb_local_only_p);

okbc_node *okbc_get_frame_handle(const char *frame, const char *kb,
				 int kb_local_only_p);

okbc_node *okbc_get_frame_in_kb(const char *thing, const char *kb,
				int error_p, int kb_local_only_p);

okbc_node *okbc_get_frame_name(const char *frame, const char *kb,
			       int kb_local_only_p);

okbc_node *okbc_get_frame_pretty_name(const char *frame, const char *kb,
				      int kb_local_only_p);

okbc_node *okbc_get_frame_sentences(const char *frame, const char *kb,
				    int number_of_values,
				    int okbc_sentences_p,
				    const char *value_selector,
				    int kb_local_only_p);

okbc_node *okbc_get_frame_slots(const char *frame, const char *kb,
				const char *inference_level,
				const char *slot_type,
				int kb_local_only_p);

okbc_node *okbc_get_frame_type(const char *thing, const char *kb,
			       int kb_local_only_p);

okbc_node *okbc_get_frames_matching(const char *pattern, const char *kb,
				    int wildcards_allowed_p,
				    const char *selector,
				    int force_case_insensitive_p,
				    int kb_local_only_p);

okbc_node *okbc_get_frames_with_facet_value(const char *slot,
					    const char *facet,
					    const char *value,
					    const char *kb,
					    const char *inference_level,
					    const char *slot_type,
					    const char *value_selector,
					    int kb_local_only_p);

okbc_node *okbc_get_frames_with_slot_value(const char *slot,
					   const char *value,
					   const char *kb,
					   const char *inference_level,
					   const char *slot_type,
					   const char *value_selector,
					   int kb_local_only_p);

okbc_node *okbc_get_instance_types(const char *frame, const char *kb,
				   const char *inference_level,
				   int number_of_values,
				   int kb_local_only_p);

okbc_node *okbc_get_kb_behaviors(const char *kb_type_or_kb,
				 const char *connection);

okbc_node *okbc_get_kb_classes(const char *kb, const char *selector,
			       int kb_local_only_p);

okbc_node *okbc_get_kb_direct_children(const char *kb);

okbc_node *okbc_get_kb_direct_parents(const char *kb);

okbc_node *okbc_get_kb_facets(const char *kb, const char *selector,
			      int kb_local_only_p);

okbc_node *okbc_get_kb_frames(const char *kb, int kb_local_only_p);

okbc_node *okbc_get_kb_individuals(const char *kb, const char *selector,
				   int kb_local_only_p);

okbc_node *okbc_get_kb_roots(const char *kb, const char *selector,
			     int kb_local_only_p);

okbc_node *okbc_get_kb_slots(const char *kb, const char *selector,
			     int kb_local_only_p);

okbc_node *okbc_get_kb_type(const char *thing, const char *connection);

okbc_node *okbc_get_kb_types(const char *connection);

okbc_node *okbc_get_kbs(const char *connection);

okbc_node *okbc_get_kbs_of_type(const char *kb_type,
				const char *connection);

okbc_node *okbc_get_procedure(const char *name, const char *kb);

okbc_node *okbc_get_slot_facets(const char *frame, const char *slot,
				const char *kb,
				const char *inference_level,
				const char *slot_type,
				int kb_local_only_p);

okbc_node *okbc_get_slot_type(const char *frame, const char *slot,
			      const char *kb, const char *inference_level,
			      int kb_local_only_p);

okbc_node *okbc_get_slot_value(const char *frame, const char *slot,
			       const char *kb, const char *inference_level,
			       const char *slot_type,
			       const char *value_selector,
			       int kb_local_only_p);

okbc_node *okbc_get_slot_values(const char *frame, const char *slot,
				const char *kb,
				const char *inference_level,
				const char *slot_type,
				int number_of_values,
				const char *value_selector,
				int kb_local_only_p);

okbc_node *okbc_get_slot_values_in_detail(const char *frame,
					  const char *slot, const char *kb,
					  const char *inference_level,
					  const char *slot_type,
					  int number_of_values,
					  const char *value_selector,
					  int kb_local_only_p);
